import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_course {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '老师id' })
  'teacher': string = undefined;
  @ApiProperty({ description: '金额' })
  'money': number = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_course extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['teacher'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '老师id' })
  'teacher': string = undefined;
}

export class QVO_course extends FVO_course {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_course {
  @ApiProperty({ description: '老师id' })
  @Rule(RuleType['string']().empty(''))
  'teacher': string = undefined;
  @ApiProperty({ description: '金额' })
  @Rule(RuleType['number']().empty(''))
  'money': number = undefined;
  @ApiProperty({ description: '开始时间' })
  @Rule(RuleType['string']().empty(''))
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  @Rule(RuleType['string']().empty(''))
  'end_time': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_course extends FVO_course {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_course extends CDTO_course {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_course extends FVO_course {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
