import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_teacher {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '微信唯一标识' })
  'openid': string = undefined;
  @ApiProperty({ description: '头像' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '所教年级' })
  'grade': string = undefined;
  @ApiProperty({ description: '身份证类型' })
  'cardType': string = undefined;
  @ApiProperty({ description: '身份证号码' })
  'card': string = undefined;
  @ApiProperty({ description: '任课年限' })
  'years': string = undefined;
  @ApiProperty({ description: '学历' })
  'education': string = undefined;
  @ApiProperty({ description: '学科' })
  'subject': string = undefined;
  @ApiProperty({ description: '院校' })
  'college': string = undefined;
  @ApiProperty({ description: '学业状态' })
  'learnStatus': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_teacher extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['openid', 'nick_name', 'gender', 'age', 'phone', 'grade', 'card', 'education', 'college', 'learnStatus', 'brief', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '微信唯一标识' })
  'openid': string = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '所教年级' })
  'grade': string = undefined;
  @ApiProperty({ description: '身份证号码' })
  'card': string = undefined;
  @ApiProperty({ description: '学历' })
  'education': string = undefined;
  @ApiProperty({ description: '院校' })
  'college': string = undefined;
  @ApiProperty({ description: '学业状态' })
  'learnStatus': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_teacher extends FVO_teacher {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_teacher {
  @ApiProperty({ description: '微信唯一标识' })
  @Rule(RuleType['string']().empty(''))
  'openid': string = undefined;
  @ApiProperty({ description: '头像' })
  @Rule(RuleType['array']().empty(''))
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '昵称' })
  @Rule(RuleType['string']().empty(''))
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  @Rule(RuleType['string']().empty(''))
  'gender': string = undefined;
  @ApiProperty({ description: '年龄' })
  @Rule(RuleType['string']().empty(''))
  'age': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '所教年级' })
  @Rule(RuleType['string']().empty(''))
  'grade': string = undefined;
  @ApiProperty({ description: '身份证类型' })
  @Rule(RuleType['string']().empty(''))
  'cardType': string = undefined;
  @ApiProperty({ description: '身份证号码' })
  @Rule(RuleType['string']().empty(''))
  'card': string = undefined;
  @ApiProperty({ description: '任课年限' })
  @Rule(RuleType['string']().empty(''))
  'years': string = undefined;
  @ApiProperty({ description: '学历' })
  @Rule(RuleType['string']().empty(''))
  'education': string = undefined;
  @ApiProperty({ description: '学科' })
  @Rule(RuleType['string']().empty(''))
  'subject': string = undefined;
  @ApiProperty({ description: '院校' })
  @Rule(RuleType['string']().empty(''))
  'college': string = undefined;
  @ApiProperty({ description: '学业状态' })
  @Rule(RuleType['string']().empty(''))
  'learnStatus': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['string']().empty(''))
  'role': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_teacher extends FVO_teacher {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_teacher extends CDTO_teacher {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_teacher extends FVO_teacher {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
